/*------------------------------------------------------------------------
--                                                                      --
--                     H E L I O S   K E R N E L                        --
--                     -------------------------                        --
--                                                                      --
--             Copyright (C) 1987, Perihelion Software Ltd.             --
--                        All Rights Reserved.                          --
--                                                                      --
-- event.h								--
--                                                                      --
--	Event channel support.						--
--                                                                      --
--	Author:  NHG 8/8/88						--
--                                                                      --
------------------------------------------------------------------------*/
/* SccsId: %W%	%G% Copyright (C) 1987, Perihelion Software Ltd.	*/
/* $Id: event.h,v 1.5 91/03/14 18:32:03 paul Exp $ */

#ifndef __event_h
#define __event_h

#ifndef __helios_h
#include <helios.h>
#endif

typedef struct Event {
	struct Node	Node;		/* link in event chain		*/
#ifdef __TRAN
	word		Pri;		/* priority in chain		*/
	VoidFnPtr	Code;		/* event routine		*/
#else
	word		Vector;		/* interrupt vector		*/
	word		Pri;		/* priority in chain		*/
	WordFnPtr	Code;		/* event routine		*/
#endif
	void		*Data;		/* data for this */
	word		*ModTab;	/* set by kernel */
	} Event;


/* Kernel support routines */

word SetEvent(Event *event);
word RemEvent(Event *event);
#ifndef __TRAN
 /* disable interrupts for the duration of this fn call */
 word AvoidEvents(WordFnPtr fn, word a, word b, word c);
#endif
#ifdef __ARM
 /* user event mechanism prototypes */
 word SetUserEvent(Event *event);
 word RemUserEvent(Event *event);
 void CauseUserEvent(word vector, word arg);
#endif


#endif

/* -- End of event.h */
